---------------------------------------------------------
--	ARKadium's Undaunted Settings Menu file	    	    -
--	Written by @Carter_DC (EU) / coirier.rom1@gmail.com -
--------------------------------------------------------- 

local LAM = LibStub("LibAddonMenu-2.0")
ARK_Undaunted      = ARK_Undaunted or {}
local UDT = ARK_Undaunted

function UDT.CreateSettingsMenu()

    local pledgeDifficultyMode ={
     [1] = "NORMAL",     
     [2] = "VETERAN",
     [3] = "VETERAN HARD MODE",
	}
   
	local panelData ={
		type = "panel",
		name = UDT.AddonName,
		displayName = UDT.displayName,
		author = UDT.author,
		version = UDT.AddonVersion,
		website = UDT.GuildWebSite,
		--slashCommand = "/ark",
		registerForRefresh = true,
		registerForDefaults = true,
	}
	LAM:RegisterAddonPanel(UDT.AddonName.."_LAM", panelData)

	local optionsTable ={
		[1] = {
			type = "description",
			text = GetString(ARK_UDT_MENU_DESCRIPTION), 
		},
		[2] = {
			type = "header",
			name = UDT.Colorize(GetString(ARK_UDT_MENU_GENERAL)),
			width = "full",
		},
		[3] = {
			type = "checkbox",
			name = "bUseDebugMode", 
			tooltip = "Only for Testers", 
			getFunc = function() return UDT.sVars.bUseDebugMode end,
			setFunc = function(value)
				UDT.sVars.bUseDebugMode = value            
			end,
			default = UDT.defaults.bUseDebugMode,
			disabled = function() return UDT.bIsTester end,
		},	
		--[[[3] = {
			type = "checkbox",
			name = "Show Start Message",
			tooltip = "Enables or Disables the Start Message",
			getFunc = function() return UDT.sVars.bEnableStartMessage end,
			setFunc = function(value)
				UDT.sVars.bEnableStartMessage = value   
			end,
			default = UDT.defaults.bEnableStartMessage,
			disabled = false,
		},]]--
		[4] = {
			type = "colorpicker",
			name = GetString(ARK_UDT_MENU_COLOR), --"Main Text Color",
			tooltip = "Default is r=204, g=10, b=0",
			getFunc = function() return UDT.GetMainTextColor() end, 
			setFunc = function(r,g,b,a)
				UDT.SetMainTextColor(r, g, b, a) 
				UDT.sVars.MainTextColor.hex = RGBAToHex(r, g, b)
			end,
			width = "full",
			default = function() return UDT.Default.MainTextColor.r, UDT.Default.MainTextColor.g, UDT.Default.MainTextColor.b, UDT.Default.MainTextColor.a end,
			disabled = false,
		},
		[5] = {
			type = "header",
			name = UDT.Colorize(GetString(ARK_UDT_MENU_DAILIES)),
			width = "full",
		},
		[6] = {
			type = "checkbox",
			name = GetString(ARK_UDT_MENU_AUTO_ABANDON), --"Auto Abandon",
			tooltip = GetString(ARK_UDT_MENU_AUTO_ABANDON_TT), --"Silently abandon all NON COMPLETED undaunted dailies",
			getFunc = function() return UDT.sVars.bAutoDelete end,
			setFunc = function(value)
				UDT.sVars.bAutoDelete = value   
				if value then
					UDT.DeleteNonCompletedDailies()
				end		  
			end,
			default = UDT.defaults.bAutoDelete,
		},
		[7] = {
		type = "checkbox",
		name = GetString(ARK_UDT_MENU_DISPLAY_DAILIES), -- "Display Dailies", 
		tooltip = GetString(ARK_UDT_MENU_DISPLAY_DAILIES_TT), --"Whether or not the list of dailies will be displayed in the client chat", 
		getFunc = function() return UDT.sVars.bAdvertizeDailies end,
		setFunc = function(value)
			UDT.sVars.bAdvertizeDailies = value            
		end,
		default = UDT.defaults.bAdvertizeDailies,
		},
		[8] = {
		type = "checkbox",
		name = GetString(ARK_UDT_MENU_QUICK_DIALOGS),--"Quick Dialogs",
		tooltip = GetString(ARK_UDT_MENU_QUICK_DIALOGS_TT),--"Auto accepts and returns quests in npc dialogs",
		getFunc = function() return UDT.sVars.bQuickDialog end,
		setFunc = function(value)
			UDT.sVars.bQuickDialog = value  
			if value then
				EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_CHATTER_BEGIN, UDT.OnChatterBegin)
			else
				EVENT_MANAGER:UnregisterForEvent(ADDON_NAME, EVENT_CHATTER_BEGIN)
			end
		end,
		default = UDT.defaults.bQuickDialog,
		},
		[9] = {
		type = "checkbox",
		name = GetString(ARK_UDT_MENU_CHEST_HELPER), --"Chest Helper",
		tooltip = GetString(ARK_UDT_MENU_CHEST_HELPER_TT), --"Displays the list of possible chest Sets.",
		getFunc = function() return UDT.sVars.bDisplayChestHelper end,
		setFunc = function(value)
			UDT.sVars.bDisplayChestHelper = value  
			if value then
				ZO_PreHook(RETICLE, "TryHandlingInteraction", UDT.TryHandlingInteraction)
			end
		end,
		default = UDT.defaults.bDisplayChestHelper,
		},
      --[[[5] ={
		type = "checkbox",
        name = GetString(ARK_UDT_MENU_DISPLAY_WS), --"Display Welcome SCreen",
        tooltip = GetString(ARK_UDT_MENU_DISPLAY_WS_TT), --"Display Welcome Screen",
        getFunc = function() return UDT.sVars.bDisplayWelcomeScreen end,
        setFunc = function(value)
          UDT.sVars.bDisplayWelcomeScreen = value            
        end,
        --width = "half", --or "half" (optional)
        default = UDT.sVars.bDisplayWelcomeScreen,
		disabled = true,
      },
	  [6] ={
        type = "dropdown",
        name = "Pledge Prefred Mode", -- GetString(AT_FINISHER_DIFFTHR_SLIDER),
        tooltip = "Not currently used",--GetString(AT_FINISHER_DIFFTHR_SLIDER_TOOLTIP),
        choices = pledgeDifficultyMode,
        getFunc = function() return pledgeDifficultyMode[UDT.sVars.pledgePreferedMode] end,
        setFunc = function(selected)
          for index, name in ipairs(pledgeDifficultyMode) do
            if name == selected then
              UDT.sVars.pledgePreferedMode = index
            break
            end
          end   
        end,
        default = pledgeDifficultyMode[UDT.defaults.pledgePreferedMode],
      },
      [7] = {
        type = "header",
        --name = "OPTIONS",
        width = "half",
      },]]-- 
  }
   
   LAM:RegisterOptionControls(UDT.AddonName.."_LAM", optionsTable)
   
end


do

	
	function UDT.GetMainTextColor()
		return UDT.sVars.MainTextColor.r, UDT.sVars.MainTextColor.g, UDT.sVars.MainTextColor.b, UDT.sVars.MainTextColor.a
	end

	function UDT.SetMainTextColor(r, g, b, a)
		UDT.sVars.MainTextColor.r = r
		UDT.sVars.MainTextColor.g = g 
		UDT.sVars.MainTextColor.b = b 
		UDT.sVars.MainTextColor.a = a 
	end

	function RGBAToHex(r, g, b, a)
	  if r>1 then r=1 end
	  if g>1 then g=1 end
	  if b>1 then b=1 end
	  
	  r = r <= 1 and r >= 0 and r or 0
	  g = g <= 1 and g >= 0 and g or 0
	  b = b <= 1 and b >= 0 and b or 0
	  if a ~= nil then
	  	  return string.format("%02x%02x%02x%02x", UDT.Round(r * 255), UDT.Round(g * 255), UDT.Round(b * 255), UDT.Round(a * 255))
		else
			return string.format("%02x%02x%02x", UDT.Round(r * 255), UDT.Round(g * 255), UDT.Round(b * 255))
		end
	end

	function HexToRGBA( hex )
		local rhex, ghex, bhex, ahex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6), string.sub(hex, 7, 8)
		return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
	end
	

end